import { Inject, Injectable } from '@nestjs/common';
import { OnEvent } from '@nestjs/event-emitter';
import { MessagePublisherPort } from '@mobicoop/ddd-library';
import { USER_MESSAGE_PUBLISHER } from '@modules/user/user.di-tokens';
import { UserUpdatedDomainEvent } from '../../domain/events/user-updated.domain-events';

@Injectable()
export class PublishMessageWhenUserIsUpdatedDomainEventHandler {
  constructor(
    @Inject(USER_MESSAGE_PUBLISHER)
    private readonly messagePublisher: MessagePublisherPort,
  ) {}

  @OnEvent(UserUpdatedDomainEvent.name, { async: true, promisify: true })
  async handle(event: UserUpdatedDomainEvent): Promise<any> {
    this.messagePublisher.publish('user.updated', JSON.stringify(event));
  }
}
